package com.jxdinfo.hussar.core;

import com.jxdinfo.hussar.core.util.LicenseInfo;
import java.security.AccessController;
import java.security.PrivilegedAction;
import java.security.ProtectionDomain;

public class HussarClassLoader extends ClassLoader {

   private static ProtectionDomain assert = (ProtectionDomain)AccessController.doPrivileged(new PrivilegedAction() {
      public Object run() {
         return HussarClassLoader.class.getProtectionDomain();
      }
   });


   public HussarClassLoader() {
      super(getParentClassLoader());
   }

   public boolean isExternalClass(Class a1) {
      ClassLoader a2;
      if((a2 = a1.getClassLoader()) == null) {
         return false;
      } else {
         Object var2;
         for(Object var10000 = var2 = a; var10000 != null; var10000 = var2 = ((ClassLoader)var2).getParent()) {
            if(var2 == a2) {
               return false;
            }
         }

         return true;
      }
   }

   public Class defineClassPublic(String a1, byte[] a2, int a3, int a4) throws ClassFormatError {
      return a.defineClass(a1, a2, a3, a4, assert);
   }

   public static ClassLoader getParentClassLoader() {
      ClassLoader var0;
      if((var0 = Thread.currentThread().getContextClassLoader()) != null) {
         try {
            var0.loadClass(LicenseInfo.class.getName());
            return var0;
         } catch (ClassNotFoundException var2) {
            ;
         }
      }

      return LicenseInfo.class.getClassLoader();
   }

   public HussarClassLoader(ClassLoader a1) {
      super(a1);
   }

}
